## GstNvBaseEnc

    GObject
        ╰──GInitiallyUnowned
            ╰──GstObject
                ╰──GstElement
                    ╰──GstVideoEncoder
                        ╰──GstNvBaseEnc

### Properties

#### aq-strength

    “aq-strength” guint

Adaptive Quantization Strength when spatial-aq is enabled from 1 (low) to 15 (aggressive), (0 = autoselect)

Flags : Read / Write

Default value : 0

#### bitrate

    “bitrate” guint

Bitrate in kbit/sec (0 = from NVENC preset)

Flags : Read / Write

Default value : 0

#### const-quality

    “const-quality” gdouble

Target Constant Quality level for VBR mode (0 = automatic)

Flags : Read / Write

Default value : 0

#### cuda-device-id

    “cuda-device-id” guint

Get the GPU device to use for operations

Flags : Read

Default value : 0

#### gop-size

    “gop-size” gint

Number of frames between intra frames (-1 = infinite)

Flags : Read / Write

Default value : 75

#### i-adapt

    “i-adapt” gboolean

Enable adaptive I-frame insert when lookahead is enabled

Flags : Read / Write

Default value : false

#### max-bitrate

    “max-bitrate” guint

Maximum Bitrate in kbit/sec (ignored for CBR mode)

Flags : Read / Write

Default value : 0

#### nonref-p

    “nonref-p” gboolean

Automatic insertion of non-reference P-frames

Flags : Read / Write

Default value : false

#### preset

    “preset” Nv-preset *

Encoding Preset

Flags : Read / Write

Default value : default (0)

#### qp-const

    “qp-const” gint

Constant quantizer (-1 = from NVENC preset)

Flags : Read / Write

Default value : -1

#### qp-const-b

    “qp-const-b” gint

Constant QP value for B frame, When >= 0, "qp-const-i" and "qp-const-p" should be also >= 0. Overwritten by "qp-const" (-1 = from NVENC preset)

Flags : Read / Write

Default value : -1

#### qp-const-i

    “qp-const-i” gint

Constant QP value for I frame, When >= 0, "qp-const-p" and "qp-const-b" should be also >= 0. Overwritten by "qp-const" (-1 = from NVENC preset)

Flags : Read / Write

Default value : -1

#### qp-const-p

    “qp-const-p” gint

Constant QP value for P frame, When >= 0, "qp-const-i" and "qp-const-b" should be also >= 0. Overwritten by "qp-const" (-1 = from NVENC preset)

Flags : Read / Write

Default value : -1

#### qp-max

    “qp-max” gint

Maximum quantizer (-1 = from NVENC preset)

Flags : Read / Write

Default value : -1

#### qp-max-b

    “qp-max-b” gint

Maximum QP value for B frame, When >= 0, "qp-max-i" and "qp-max-p" should be also >= 0. Overwritten by "qp-max" (-1 = from NVENC preset)

Flags : Read / Write

Default value : -1

#### qp-max-i

    “qp-max-i” gint

Maximum QP value for I frame, When >= 0, "qp-max-p" and "qp-max-b" should be also >= 0. Overwritten by "qp-max" (-1 = from NVENC preset)

Flags : Read / Write

Default value : -1

#### qp-max-p

    “qp-max-p” gint

Maximum QP value for P frame, When >= 0, "qp-max-i" and "qp-max-b" should be also >= 0. Overwritten by "qp-max" (-1 = from NVENC preset)

Flags : Read / Write

Default value : -1

#### qp-min

    “qp-min” gint

Minimum quantizer (-1 = from NVENC preset)

Flags : Read / Write

Default value : -1

#### qp-min-b

    “qp-min-b” gint

Minimum QP value for B frame, When >= 0, "qp-min-i" and "qp-min-p" should be also >= 0. Overwritten by "qp-min" (-1 = from NVENC preset)

Flags : Read / Write

Default value : -1

#### qp-min-i

    “qp-min-i” gint

Minimum QP value for I frame, When >= 0, "qp-min-p" and "qp-min-b" should be also >= 0. Overwritten by "qp-min" (-1 = from NVENC preset)

Flags : Read / Write

Default value : -1

#### qp-min-p

    “qp-min-p” gint

Minimum QP value for P frame, When >= 0, "qp-min-i" and "qp-min-b" should be also >= 0. Overwritten by "qp-min" (-1 = from NVENC preset)

Flags : Read / Write

Default value : -1

#### rc-mode

    “rc-mode” Nv-rcmode *

Rate Control Mode

Flags : Read / Write

Default value : default (0)

#### spatial-aq

    “spatial-aq” gboolean

Spatial Adaptive Quantization

Flags : Read / Write

Default value : false

#### strict-gop

    “strict-gop” gboolean

Minimize GOP-to-GOP rate fluctuations

Flags : Read / Write

Default value : false

#### zerolatency

    “zerolatency” gboolean

Zero latency operation (no reordering delay)

Flags : Read / Write

Default value : false

### Named constants

#### Nv-preset

##### Members

`default` (0) – Default
`hp` (1) – High Performance
`hq` (2) – High Quality
`low-latency` (3) – Low Latency
`low-latency-hq` (4) – Low Latency, High Quality
`low-latency-hp` (5) – Low Latency, High Performance
`lossless` (6) – Lossless
`lossless-hp` (7) – Lossless, High Performance

#### Nv-rcmode

##### Members

`default` (0) – Default
`constqp` (1) – Constant Quantization
`cbr` (2) – Constant Bit Rate
`vbr` (3) – Variable Bit Rate
`vbr-minqp` (4) – Variable Bit Rate (with minimum quantization parameter, DEPRECATED)
`cbr-ld-hq` (5) – Low-Delay CBR, High Quality
`cbr-hq` (6) – CBR, High Quality (slower)
`vbr-hq` (7) – VBR, High Quality (slower)

The results of the search are